<?
	//*************************************************************************
	// Set variables
	//*************************************************************************
	//-----------------------------------
	// set db variables
	//-----------------------------------
	$sql_srv="localhost";
	$sql_usr="dbuser";
	$sql_pwd="dbpassword";
	$sql_db="database_name";
	
	//-----------------------------------
	// set prefix for the tables
	//-----------------------------------
	$table_prefix= "stats_";

	//-----------------------------------
	// connect to the db
	//-----------------------------------
	$db_link = @mysql_connect($sql_srv,$sql_usr,$sql_pwd);
	if(!$db_link) {echo "Unable to connect to DB <b>$sql_db</b> on <b>$sql_srv</b>"; exit;}

	//-----------------------------------
	// retrieve the team id
	//-----------------------------------
	$team = "";
	// retrieve the team number...
	$sql = "select TEM_ID from ".$table_prefix."team";
	$result = @mysql_db_query($sql_db, $sql, $db_link);
	if (($result)&&(mysql_num_rows($result) > 0)){
		$rs = mysql_fetch_array($result);
		$team= $rs["TEM_ID"];
	}
	if ($team == ""){echo "Unable to retrieve the team id, check the DB configuration"; exit;}
	
	//*************************************************************************
	// format a number (add "st","nd","rd","th" where necessary)
	//*************************************************************************
	function f_num($number){
		if (($number >= 10) &&($number < 20))
			return $number."th";
		else 	{
			switch ($number % 10) {
				case 1:
					return $number."st";
					break;
				case 2:
					return $number."nd";
					break;
				case 3:
					return $number."rd";
					break;
				default:
					return $number."th";
					break;
			}
		}
	}

	//*************************************************************************
	// update the db with the stats from stanford
	//*************************************************************************
	function updateStats(){
		global $sql_db, $db_link, $table_prefix;
		global $team;
		
		
		$file_path = "http://folding.stanford.edu/teamstats/team$team.txt";
		// retrieve the file
		$contents = @file($file_path);
		if ($contents != NULL){
			$start_user = false;
			$start_team = false;
			$team_count = 0;
			//clear the existing data
			$sql = "delete from ".$table_prefix."users";
			@mysql_db_query($sql_db, $sql, $db_link);
			for ($i=0; $i<sizeof($contents);$i++){
				$col = explode(chr(9) , $contents[$i]);

				//team stats information
				if (($start_team) && (trim($col[0]) == $team)) {
					$team_name = trim($col[1]);
					$team_score = trim($col[2]);
					$team_wu =	trim($col[3]);
					$sql = "update ".$table_prefix."team set TEM_NAME= \"$team_name\" , TEM_SCORE= \"$team_score\" , TEM_WU = \"$team_wu\"";
					@mysql_db_query($sql_db, $sql, $db_link);
					$start_team = false;
				}

				//team rank information
				if (substr($col[0],0, 10) == 'Team rank:')  {
					$team_rank = trim(substr($col[0],10,10));
					$sql = "update ".$table_prefix."team set TEM_RANK= \"$team_rank\"";
					@mysql_db_query($sql_db, $sql, $db_link);
				}

				//found a new user, add it!
				if (($start_user) && (trim($col[0]) != "")) {
					$usr_name = trim($col[2]);
					$usr_name =str_replace('"', '\"', $usr_name);

					$usr_score = trim($col[3]);
					$usr_wu = trim($col[4]);
					$usr_rank = trim($col[1]);
					$usr_grank = trim($col[0]);
					$sql = "insert into ".$table_prefix."users (USR_ACCOUNT, USR_SCORE, USR_WU, USR_RANK, USR_GRANK) " .  
								 "values (\"$usr_name\", \"$usr_score\", \"$usr_wu\", \"$usr_rank\", \"$usr_grank\")";
					if (@mysql_db_query($sql_db, $sql, $db_link)) $team_count = $team_count +1;
				}

				if ($col[0] == 'rank') $start_user = true;
				if ($col[0] == 'team') $start_team = true;
			}		

			//update the total number of user...
			$sql = "update ".$table_prefix."team set TEM_USERS=$team_count";
			@mysql_db_query($sql_db, $sql, $db_link);
		}
	}

	//*************************************************************************
	// main 
	//*************************************************************************
	if ($refreshdb==1) updateStats();
			
	//-----------------------------------
	// retrieve the data for the user...
	//-----------------------------------
	$bg_file = "fahsig_$bg.jpg";
	
	//couldn't find the file, use the default background...
	if (!file_exists($bg_file))
		 $bg_file = "fahsig.jpg";
		 
	// we have an user, we try to retrieve the data!
	if ($user != ""){
		$sql = "select USR_ACCOUNT, USR_SCORE, USR_WU, USR_RANK, USR_GRANK, 
						TEM_NAME, TEM_USERS, TEM_SCORE, TEM_WU, TEM_RANK 
						from ".$table_prefix."users, ".$table_prefix."team 
						where UCASE(USR_ACCOUNT) = \"". strtoupper($user)."\" 
						order by USR_RANK";
		$result = @mysql_db_query($sql_db, $sql, $db_link);

		//we retrieved something!
		if (($result)&&(mysql_num_rows($result) > 0)){
			$rs = mysql_fetch_array($result);

			header("Content-type: image/png"); 

			
			$im_size = getimagesize ($bg_file); 
			
			// create a new image having the size of the background.
			$im = imageCreate( $im_size[0], $im_size[1] ); 

			$black = imagecolorallocate ($im, 0, 0, 0);
			$blue = imagecolorallocate($im, 0, 0, 255); 

			//load the background
			$im2 = imagecreatefromjpeg($bg_file); 
			imagecopy($im,$im2,0,0,0,0, $im_size[0], $im_size[1]); 
			imagedestroy($im2); 


			$y = 30;
			
			// write down the stats...
			
			imagestring ($im, 2,  15, $y,"Username:", $black);
			imagestring ($im, 3,  85, $y, $rs["USR_ACCOUNT"], $blue);

			imagestring ($im, 2,  15, $y+15,"Score:", $black);
			imagestring ($im, 2,  85, $y+15,sprintf("%0.2f", $rs["USR_SCORE"]), $blue);

			imagestring ($im, 2,  175, $y+15,"WUs:", $black);
			imagestring ($im, 2,  235, $y+15,$rs["USR_WU"], $blue);

			imagestring ($im, 2,  15, $y+30,"Team rank:", $black);
			imagestring ($im, 2,  85, $y+30,f_num($rs["USR_RANK"]) , $blue);

			imagestring ($im, 2,  175, $y+30,"Rank:", $black);
			imagestring ($im, 2,  235, $y+30, f_num($rs["USR_GRANK"]), $blue);


			imagestring ($im, 2,  15, $y+55,"Team:", $black);
			imagestring ($im, 3,  85, $y+55,$rs["TEM_NAME"] ." (#$team)", $blue);

			imagestring ($im, 2,  15, $y+70,"Score:", $black);
			imagestring ($im, 2,  85, $y+70,sprintf("%0.2f", $rs["TEM_SCORE"]), $blue);

			imagestring ($im, 2,  175, $y+70,"WUs:", $black);
			imagestring ($im, 2,  235, $y+70,$rs["TEM_WU"], $blue);

			imagestring ($im, 2,  15, $y+85,"Rank:", $black);
			imagestring ($im, 2,  85, $y+85,f_num($rs["TEM_RANK"]), $blue);

			imagestring ($im, 2,  175, $y+85,"Members:", $black);
			imagestring ($im, 2,  235, $y+85,$rs["TEM_USERS"], $blue);

			imagepng($im);
		}
		else{
			header("Content-type: image/png"); 
			$im = imagecreatefromjpeg ($bg_file);

			$black = imagecolorallocate ($im, 0, 0, 0);
			imagestring ($im, 2,  15, 132,"$user was not found in team #$team", $black);
			imagepng($im);
		}
	}
?>